#include <stdio.h>
/* rand */
#include <stdlib.h>

#include "world.h"
#include "creature.h"
#include "load.h"
#include "map-blocked.h"

#include "build.h"

static int build_grid(world *wp);
static int build_other(world *wp);

static int
build_grid(world *wp)
{
  int x;
  int y;

  if (wp == NULL)
    return 1;

  for (x = 0; x < wp->size_x; x++)
  {
    for (y = 0; y < wp->size_y; y++)
    {
      wp->grid[x][y] = 0;
    }
  }
  for (x = 0; x < wp->size_x; x++)
  {
    wp->grid[x][0] = 1;
    wp->grid[x][wp->size_y - 1] = 1;
  }
  for (y = 0; y < wp->size_y; y++)
  {
    wp->grid[0][y] = 1;
    wp->grid[wp->size_x - 1][y] = 1;
  }

  return 0;
}

static int
build_other(world *wp)
{
  int x;
  int y;

  if (wp == NULL)
    return 1;

  for (x = 0; x < wp->size_x; x++)
  {
    for (y = 0; y < wp->size_y; y++)
    {
      if (wp->grid[x][y])
        wp->map_blocked[x][y] = MAP_BLOCKED_WALL;
      else
        wp->map_blocked[x][y] = 0;
    }
  }

  return 0;
}

int
build_game(world *wp, const char *map_file)
{
  if (wp == NULL)
  {
    fprintf(stderr, "build_game: wp is NULL\n");
    return 1;
  }

  build_grid(wp);

  if (load_map(wp, map_file) != 0)
  {
    fprintf(stderr, "build_game: load_map failed\n");
    return 1;
  }

  build_other(wp);

  return 0;
}
