#include <stdio.h>
#include <curses.h>

#include "world.h"
#include "creature.h"
#include "action.h"

#include "loop-input.h"

int
loop_input(world *wp)
{
  int c;
  creature *player = NULL;

  if (wp == NULL)
  {
    fprintf(stderr, "loop_input: wp is NULL\n");
    return 1;
  }

  if (wp->cr[wp->player_id] == NULL)
  {
    fprintf(stderr, "loop_input: wp->cr[%d] is NULL\n", wp->player_id);
    return 1;
  }
  player = wp->cr[wp->player_id];

  c = getch();

  switch (c)
  {
  case 'Q':
    wp->should_quit = 1;
    return 0;
    break;
  default:
    break;
  }

  switch (c)
  {
  case '7':
  case 'y':
    player->dx = -1;
    player->dy = -1;
    break;
  case '8':
  case 'k':
  case KEY_UP:
    player->dx = 0;
    player->dy = -1;
    break;
  case '9':
  case 'u':
    player->dx = 1;
    player->dy = -1;
    break;
  case '4':
  case 'h':
  case KEY_LEFT:
    player->dx = -1;
    player->dy = 0;
    break;
  case '5':
  case '.':
    player->dx = 0;
    player->dy = 0;
    break;
  case '6':
  case 'l':
  case KEY_RIGHT:
    player->dx = 1;
    player->dy = 0;
    break;
  case '1':
  case 'b':
    player->dx = -1;
    player->dy = 1;
    break;
  case '2':
  case 'j':
  case KEY_DOWN:
    player->dx = 0;
    player->dy = 1;
    break;
  case '3':
  case 'n':
    player->dx = 1;
    player->dy = 1;
    break;
  default:
    break;
  }

  if (!check_walk(wp, player->id, player->dx, player->dy))
  {
    player->dx = 0;
    player->dy = 0;
  }
  else
  {
    wp->player_decided = 1;
  }

  return 0;
}
