#include <stdio.h>

#include "world.h"
#include "action.h"
#include "monster.h"

#include "loop-process.h"

int
loop_process(world *wp)
{
  int i;

  if (wp == NULL)
  {
    fprintf(stderr, "loop_process: wp is NULL\n");
    return 1;
  }

  if (!(wp->player_decided))
    return 0;

  if ((wp->player_id < 0) || (wp->player_id >= wp->cr_size))
    return 0;
  if (wp->cr[wp->player_id] == NULL)
    return 0;
  if (wp->cr[wp->player_id] <= 0)
    return 0;

  exec_walk(wp, wp->player_id);

  wp->cr[wp->player_id]->dx = 0;
  wp->cr[wp->player_id]->dy = 0;

  /* this must be called after the player action is done */
  monster_decide_action(wp);

  for (i = 0; i < wp->cr_size; i++)
  {
    if (i == wp->player_id)
      continue;

    if (wp->cr[i] == NULL)
      continue;
    if (wp->cr[i]->hp <= 0)
      continue;

    exec_walk(wp, i);

    wp->cr[i]->dx = 0;
    wp->cr[i]->dy = 0;
  }

  wp->player_decided = 0;

  return 0;
}
