#ifndef __SURROUND_WORLD_H__
#define __SURROUND_WORLD_H__

#include <curses.h>

#include "creature.h"
#include "dijkstra.h"

struct _world
{
  int cr_size;
  creature **cr;
  int size_x;
  int size_y;
  /* non-zero if and only if it is a wall */
  int **grid;
  int player_id;
  WINDOW *scr;
  int scr_size_x;
  int scr_size_y;
  int should_quit;
  int player_decided;
  int player_damage;
  dijkstra_map **dijkp;
  int **map_blocked;
  int num_engage;
  int *engage_id;
  int *engage_num_choice;
  int no_surround;
  int no_hesitate;
};
typedef struct _world world;

world *world_new(void);
void world_delete(world *wp);

#endif /* not __SURROUND_WORLD_H__ */
